package com.madeu.dao.web.webyoutube;

import jakarta.annotation.PostConstruct;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.support.SqlSessionDaoSupport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Repository
public class WebYouTubeSqlMapDAO extends SqlSessionDaoSupport{

    @Autowired
    private SqlSessionTemplate sqlSessionTemplate;

    @PostConstruct
    void init() {
        setSqlSessionTemplate(sqlSessionTemplate);
    }

    /**
     * 홈페이지 유튜브 정보 총 갯수 조회 (total count)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectTotalWebYouTubeCount(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebYouTubeSqlMapDAO selectTotalWebYouTubeCount START");
        String sqlId = "WebYouTube.selectTotalWebYouTubeCount";
        logger.debug("WebYouTubeSqlMapDAO selectTotalWebYouTubeCount END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 유튜브 정보 리스트 조회 (List)
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectListWebYouTube(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebYouTubeSqlMapDAO selectListWebYouTube START");
        String sqlId = "WebYouTube.selectListWebYouTube";
        logger.debug("WebYouTubeSqlMapDAO selectListWebYouTube END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 유튜브 정보 조회
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public List<Map<String, Object>> selectWebYouTube(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebYouTubeSqlMapDAO selectWebYouTube START");
        String sqlId = "WebYouTube.selectWebYouTube";
        logger.debug("WebYouTubeSqlMapDAO selectWebYouTube END");
        return getSqlSession().selectList(sqlId, paramMap);
    }

    /**
     * 홈페이지 유튜브 정보 등록
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int insertWebYouTube(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebYouTubeSqlMapDAO insertWebYouTube START");
        String sqlId = "WebYouTube.insertWebYouTube";
        logger.debug("WebYouTubeSqlMapDAO insertWebYouTube END");
        return getSqlSession().insert(sqlId, paramMap);
    }

    /**
     * 홈페이지 유튜브 정보 수정
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int updateWebYouTube(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebYouTubeSqlMapDAO updateWebYouTube START");
        String sqlId = "WebYouTube.updateWebYouTube";
        logger.debug("WebYouTubeSqlMapDAO updateWebYouTube END");
        return getSqlSession().update(sqlId, paramMap);
    }

    /**
     * 홈페이지 유튜브 정보 삭제
     *
     * @param Map
     * @return
     * @throws DataAccessException
     */
    public int deleteWebYouTube(HashMap<String, Object> paramMap)
            throws DataAccessException {
        logger.debug("WebYouTubeSqlMapDAO deleteWebYouTube START");
        String sqlId = "WebYouTube.deleteWebYouTube";
        logger.debug("WebYouTubeSqlMapDAO deleteWebYouTube END");
        return getSqlSession().update(sqlId, paramMap);
    }

}
